library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity route is 
    generic( 
        INPUT_WIDTH: integer := GENERIC_INPUT_WIDTH_PARAM;
        OUTPUT_WIDTH: integer := GENERIC_OUTPUT_WIDTH_PARAM
    );
    port(
        PRM_ERROR         : out std_logic_vector(3 downto 0);

        OUTPUT_FU1        : in std_logic_vector(OUTPUT_WIDTH-1 downto 0);    
        OUTPUT_FU2        : in std_logic_vector(OUTPUT_WIDTH-1 downto 0);

        OUTPUT            : out std_logic_vector(OUTPUT_WIDTH-1 downto 0); 
        
        INPUT             : in std_logic_vector(INPUT_WIDTH-1 downto 0);

        INPUT_FU1         : out std_logic_vector(INPUT_WIDTH-1 downto 0);
        INPUT_FU2         : out std_logic_vector(INPUT_WIDTH-1 downto 0)
    );  
end route;


architecture route_behavioral of route is

signal error_sig : std_logic;
    


begin
    error_sig <= '0' when OUTPUT_FU1 = OUTPUT_FU2 else '1';

    OUTPUT <= OUTPUT_FU1;
    PRM_ERROR(0) <= error_sig;
    PRM_ERROR(1) <= error_sig; 
    PRM_ERROR(2) <= '0';
    PRM_ERROR(3) <= '0';
    
    
    -- pripojeni vstupu vsech dvou jednotek k vstupnim signalum
    INPUT_FU1 <= INPUT;
    INPUT_FU2 <= INPUT;
    --INPUT_FU3_UNUSED <= (others=>'0');
     
end route_behavioral;
