library IEEE;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity voter is
generic ( 
    DATA_WIDTH: integer := 8
);
port(
    DATA1 : in std_logic_vector(DATA_WIDTH-1 downto 0);
    DATA2 : in std_logic_vector(DATA_WIDTH-1 downto 0);
    DATA3 : in std_logic_vector(DATA_WIDTH-1 downto 0);
    DATA  : out std_logic_vector(DATA_WIDTH-1 downto 0);
    ERR1  : out std_logic; 
    ERR2  : out std_logic; 
    ERR3  : out std_logic 
); 
end voter;

architecture voter_behavioral of voter is
    signal data12_and_sig, data13_and_sig, data23_and_sig : std_logic;

begin
    data12_and_sig <= '1' when (( DATA1 and DATA2 ) = conv_std_logic_vector(0, DATA_WIDTH) ) else '0';
    data13_and_sig <= '1' when (( DATA1 and DATA3 ) = conv_std_logic_vector(0, DATA_WIDTH) ) else '0';
    data23_and_sig <= '1' when (( DATA2 and DATA3 ) = conv_std_logic_vector(0, DATA_WIDTH) ) else '0';
    
    ERR1 <= NOT(data12_and_sig) and (data23_and_sig);
    ERR2 <= NOT(data12_and_sig) and (data13_and_sig);
    ERR3 <= NOT(data13_and_sig) and (data12_and_sig);
  
    DATA <= (DATA1 and DATA2) or (DATA2 and DATA3) or (DATA1 and DATA3);
  
end voter_behavioral;
